///////////////////////////////////////////////////////////////////////////////
// Tyler Perkins
// 9-23-21
// parse implementations
//

#include "parse.h"

char ops[] = {'+','-','*','/','.','<','>','\0'};

int op_add(){
    int ret = 0;
    for(int it = 0;it < 2; ++it){
        ret += pop();
        if(_head_error == POP_EMPTY_STACK){
            return -1;
        }
    }
    
    push(ret);
    return 0;
}

int op_sub(){
    int op[2];
    for(int it = 0;it < 2; ++it){
        op[it] = pop();
        if(_head_error == POP_EMPTY_STACK){
            return -1;
        }
    }
    
    push(op[1] - op[0]);
    return 0;
}

int op_mul(){
    int ret = 1;
    for(int it = 0;it < 2; ++it){
        ret *= pop();
        if(_head_error == POP_EMPTY_STACK){
            return -1;
        }
    }
    
    push(ret);
    return 0;
}

int op_div(){
    int op[2];
    for(int it = 0;it < 2; ++it){
        op[it] = pop();
        if(_head_error == POP_EMPTY_STACK){
            return -1;
        }
    }
    
    push(op[1]/op[0]);
    return 0;
}

int op_pri(){
    printf("%d\n", peek());
    if(_head_error == PEEK_EMPTY_STACK){
        return -1;
    }
    return 0;
}

int op_right(){
    int ret = pop();
    if(_head_error == POP_EMPTY_STACK){
        return -1;
    }

    ret = ret >> 1;
    push(ret);
    return 0;
}

int op_left(){
    int ret = pop();
    if(_head_error == POP_EMPTY_STACK){
        return -1;
    }

    ret = ret << 1;
    push(ret);
    return 0;
}

int parse(const char* input){
    short int i = 0;
    short int j = 0;
    int ret = 0;
    char buf[BUFFER_MAX_SIZE] = {'\0'};

    while(input[i] != '\0'){
        //collect it into a temporary buffer
        if(input[i] == ' ' || input[i] == '\n' || input[i] == '\t'){
            if(j == 1 && (strstr(ops,buf) != NULL)){ //if single operator
                //apply operator
                switch(buf[0]){
                    case '+':
                        ret = op_add();
                        break;
                    case '-':
                        ret = op_sub();
                        break;
                    case '*':
                        ret = op_mul();
                        break;
                    case '/':
                        ret = op_div();
                        break;
                    case '.':
                        ret = op_pri();
                        break;
                    case '<':
                        ret = op_left();
                        break;
                    case '>':
                        ret = op_right();
                        break;
                    default:
                }

                if(ret == -1){
                    return i;
                }
                //TODO parse as token in dictionary
            } else { //Is number
                ret = atoi(buf);
                push(ret);
            }

            //clean up buf
            memset(buf, '\0', j+1);
            j = 0;
        } else { //not whitespace
            
            buf[j] = input[i];
            ++j;
        }

        ++i;
    }

    return -1;
}
